/*
	This file is part of Fennix Kernel.

	Fennix Kernel is free software: you can redistribute it and/or
	modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation, either version 3 of
	the License, or (at your option) any later version.

	Fennix Kernel is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Fennix Kernel. If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef __FENNIX_KERNEL_LINUX_SYSCALLS_I386_H__
#define __FENNIX_KERNEL_LINUX_SYSCALLS_I386_H__

#define __NR_i386_restart_syscall 0
#define __NR_i386_exit 1
#define __NR_i386_fork 2
#define __NR_i386_read 3
#define __NR_i386_write 4
#define __NR_i386_open 5
#define __NR_i386_close 6
#define __NR_i386_waitpid 7
#define __NR_i386_creat 8
#define __NR_i386_link 9
#define __NR_i386_unlink 10
#define __NR_i386_execve 11
#define __NR_i386_chdir 12
#define __NR_i386_time 13
#define __NR_i386_mknod 14
#define __NR_i386_chmod 15
#define __NR_i386_lchown 16
#define __NR_i386_break 17
#define __NR_i386_oldstat 18
#define __NR_i386_lseek 19
#define __NR_i386_getpid 20
#define __NR_i386_mount 21
#define __NR_i386_umount 22
#define __NR_i386_setuid 23
#define __NR_i386_getuid 24
#define __NR_i386_stime 25
#define __NR_i386_ptrace 26
#define __NR_i386_alarm 27
#define __NR_i386_oldfstat 28
#define __NR_i386_pause 29
#define __NR_i386_utime 30
#define __NR_i386_stty 31
#define __NR_i386_gtty 32
#define __NR_i386_access 33
#define __NR_i386_nice 34
#define __NR_i386_ftime 35
#define __NR_i386_sync 36
#define __NR_i386_kill 37
#define __NR_i386_rename 38
#define __NR_i386_mkdir 39
#define __NR_i386_rmdir 40
#define __NR_i386_dup 41
#define __NR_i386_pipe 42
#define __NR_i386_times 43
#define __NR_i386_prof 44
#define __NR_i386_brk 45
#define __NR_i386_setgid 46
#define __NR_i386_getgid 47
#define __NR_i386_signal 48
#define __NR_i386_geteuid 49
#define __NR_i386_getegid 50
#define __NR_i386_acct 51
#define __NR_i386_umount2 52
#define __NR_i386_lock 53
#define __NR_i386_ioctl 54
#define __NR_i386_fcntl 55
#define __NR_i386_mpx 56
#define __NR_i386_setpgid 57
#define __NR_i386_ulimit 58
#define __NR_i386_oldolduname 59
#define __NR_i386_umask 60
#define __NR_i386_chroot 61
#define __NR_i386_ustat 62
#define __NR_i386_dup2 63
#define __NR_i386_getppid 64
#define __NR_i386_getpgrp 65
#define __NR_i386_setsid 66
#define __NR_i386_sigaction 67
#define __NR_i386_sgetmask 68
#define __NR_i386_ssetmask 69
#define __NR_i386_setreuid 70
#define __NR_i386_setregid 71
#define __NR_i386_sigsuspend 72
#define __NR_i386_sigpending 73
#define __NR_i386_sethostname 74
#define __NR_i386_setrlimit 75
#define __NR_i386_getrlimit 76
#define __NR_i386_getrusage 77
#define __NR_i386_gettimeofday_time32 78
#define __NR_i386_settimeofday_time32 79
#define __NR_i386_getgroups 80
#define __NR_i386_setgroups 81
#define __NR_i386_select 82
#define __NR_i386_symlink 83
#define __NR_i386_oldlstat 84
#define __NR_i386_readlink 85
#define __NR_i386_uselib 86
#define __NR_i386_swapon 87
#define __NR_i386_reboot 88
#define __NR_i386_readdir 89
#define __NR_i386_mmap 90
#define __NR_i386_munmap 91
#define __NR_i386_truncate 92
#define __NR_i386_ftruncate 93
#define __NR_i386_fchmod 94
#define __NR_i386_fchown 95
#define __NR_i386_getpriority 96
#define __NR_i386_setpriority 97
#define __NR_i386_profil 98
#define __NR_i386_statfs 99
#define __NR_i386_fstatfs 100
#define __NR_i386_ioperm 101
#define __NR_i386_socketcall 102
#define __NR_i386_syslog 103
#define __NR_i386_setitimer 104
#define __NR_i386_getitimer 105
#define __NR_i386_stat 106
#define __NR_i386_lstat 107
#define __NR_i386_fstat 108
#define __NR_i386_olduname 109
#define __NR_i386_iopl 110
#define __NR_i386_vhangup 111
#define __NR_i386_idle 112
#define __NR_i386_vm86old 113
#define __NR_i386_wait4 114
#define __NR_i386_swapoff 115
#define __NR_i386_sysinfo 116
#define __NR_i386_ipc 117
#define __NR_i386_fsync 118
#define __NR_i386_sigreturn 119
#define __NR_i386_clone 120
#define __NR_i386_setdomainname 121
#define __NR_i386_uname 122
#define __NR_i386_modify_ldt 123
#define __NR_i386_adjtimex 124
#define __NR_i386_mprotect 125
#define __NR_i386_sigprocmask 126
#define __NR_i386_create_module 127
#define __NR_i386_init_module 128
#define __NR_i386_delete_module 129
#define __NR_i386_get_kernel_syms 130
#define __NR_i386_quotactl 131
#define __NR_i386_getpgid 132
#define __NR_i386_fchdir 133
#define __NR_i386_bdflush 134
#define __NR_i386_sysfs 135
#define __NR_i386_personality 136
#define __NR_i386_afs_syscall 137
#define __NR_i386_setfsuid 138
#define __NR_i386_setfsgid 139
#define __NR_i386__llseek 140
#define __NR_i386_getdents 141
#define __NR_i386__newselect 142
#define __NR_i386_flock 143
#define __NR_i386_msync 144
#define __NR_i386_readv 145
#define __NR_i386_writev 146
#define __NR_i386_getsid 147
#define __NR_i386_fdatasync 148
#define __NR_i386__sysctl 149
#define __NR_i386_mlock 150
#define __NR_i386_munlock 151
#define __NR_i386_mlockall 152
#define __NR_i386_munlockall 153
#define __NR_i386_sched_setparam 154
#define __NR_i386_sched_getparam 155
#define __NR_i386_sched_setscheduler 156
#define __NR_i386_sched_getscheduler 157
#define __NR_i386_sched_yield 158
#define __NR_i386_sched_get_priority_max 159
#define __NR_i386_sched_get_priority_min 160
#define __NR_i386_sched_rr_get_interval 161
#define __NR_i386_nanosleep 162
#define __NR_i386_mremap 163
#define __NR_i386_setresuid 164
#define __NR_i386_getresuid 165
#define __NR_i386_vm86 166
#define __NR_i386_query_module 167
#define __NR_i386_poll 168
#define __NR_i386_nfsservctl 169
#define __NR_i386_setresgid 170
#define __NR_i386_getresgid 171
#define __NR_i386_prctl 172
#define __NR_i386_rt_sigreturn 173
#define __NR_i386_rt_sigaction 174
#define __NR_i386_rt_sigprocmask 175
#define __NR_i386_rt_sigpending 176
#define __NR_i386_rt_sigtimedwait 177
#define __NR_i386_rt_sigqueueinfo 178
#define __NR_i386_rt_sigsuspend 179
#define __NR_i386_pread64 180
#define __NR_i386_pwrite64 181
#define __NR_i386_chown 182
#define __NR_i386_getcwd 183
#define __NR_i386_capget 184
#define __NR_i386_capset 185
#define __NR_i386_sigaltstack 186
#define __NR_i386_sendfile 187
#define __NR_i386_getpmsg 188
#define __NR_i386_putpmsg 189
#define __NR_i386_vfork 190
#define __NR_i386_ugetrlimit 191
#define __NR_i386_mmap2 192
#define __NR_i386_truncate64 193
#define __NR_i386_ftruncate64 194
#define __NR_i386_stat64 195
#define __NR_i386_lstat64 196
#define __NR_i386_fstat64 197
#define __NR_i386_lchown32 198
#define __NR_i386_getuid32 199
#define __NR_i386_getgid32 200
#define __NR_i386_geteuid32 201
#define __NR_i386_getegid32 202
#define __NR_i386_setreuid32 203
#define __NR_i386_setregid32 204
#define __NR_i386_getgroups32 205
#define __NR_i386_setgroups32 206
#define __NR_i386_fchown32 207
#define __NR_i386_setresuid32 208
#define __NR_i386_getresuid32 209
#define __NR_i386_setresgid32 210
#define __NR_i386_getresgid32 211
#define __NR_i386_chown32 212
#define __NR_i386_setuid32 213
#define __NR_i386_setgid32 214
#define __NR_i386_setfsuid32 215
#define __NR_i386_setfsgid32 216
#define __NR_i386_pivot_root 217
#define __NR_i386_mincore 218
#define __NR_i386_madvise 219
#define __NR_i386_getdents64 220
#define __NR_i386_fcntl64 221
#define __NR_i386_gettid 224
#define __NR_i386_readahead 225
#define __NR_i386_setxattr 226
#define __NR_i386_lsetxattr 227
#define __NR_i386_fsetxattr 228
#define __NR_i386_getxattr 229
#define __NR_i386_lgetxattr 230
#define __NR_i386_fgetxattr 231
#define __NR_i386_listxattr 232
#define __NR_i386_llistxattr 233
#define __NR_i386_flistxattr 234
#define __NR_i386_removexattr 235
#define __NR_i386_lremovexattr 236
#define __NR_i386_fremovexattr 237
#define __NR_i386_tkill 238
#define __NR_i386_sendfile64 239
#define __NR_i386_futex 240
#define __NR_i386_sched_setaffinity 241
#define __NR_i386_sched_getaffinity 242
#define __NR_i386_set_thread_area 243
#define __NR_i386_get_thread_area 244
#define __NR_i386_io_setup 245
#define __NR_i386_io_destroy 246
#define __NR_i386_io_getevents 247
#define __NR_i386_io_submit 248
#define __NR_i386_io_cancel 249
#define __NR_i386_fadvise64 250
#define __NR_i386_set_zone_reclaim 251 /* removed in 2.6.16 */
#define __NR_i386_exit_group 252
#define __NR_i386_lookup_dcookie 253
#define __NR_i386_epoll_create 254
#define __NR_i386_epoll_ctl 255
#define __NR_i386_epoll_wait 256
#define __NR_i386_remap_file_pages 257
#define __NR_i386_set_tid_address 258
#define __NR_i386_timer_create 259
#define __NR_i386_timer_settime32 260
#define __NR_i386_timer_gettime32 261
#define __NR_i386_timer_getoverrun 262
#define __NR_i386_timer_delete 263
#define __NR_i386_clock_settime32 264
#define __NR_i386_clock_gettime32 265
#define __NR_i386_clock_getres_time32 266
#define __NR_i386_clock_nanosleep_time32 267
#define __NR_i386_statfs64 268
#define __NR_i386_fstatfs64 269
#define __NR_i386_tgkill 270
#define __NR_i386_utimes 271
#define __NR_i386_fadvise64_64 272
#define __NR_i386_vserver 273
#define __NR_i386_mbind 274
#define __NR_i386_get_mempolicy 275
#define __NR_i386_set_mempolicy 276
#define __NR_i386_mq_open 277
#define __NR_i386_mq_unlink 278
#define __NR_i386_mq_timedsend 279
#define __NR_i386_mq_timedreceive 280
#define __NR_i386_mq_notify 281
#define __NR_i386_mq_getsetattr 282
#define __NR_i386_kexec_load 283
#define __NR_i386_waitid 284
#define __NR_i386_sys_setaltroot 285
#define __NR_i386_add_key 286
#define __NR_i386_request_key 287
#define __NR_i386_keyctl 288
#define __NR_i386_ioprio_set 289
#define __NR_i386_ioprio_get 290
#define __NR_i386_inotify_init 291
#define __NR_i386_inotify_add_watch 292
#define __NR_i386_inotify_rm_watch 293
#define __NR_i386_migrate_pages 294
#define __NR_i386_openat 295
#define __NR_i386_mkdirat 296
#define __NR_i386_mknodat 297
#define __NR_i386_fchownat 298
#define __NR_i386_futimesat 299
#define __NR_i386_fstatat64 300
#define __NR_i386_unlinkat 301
#define __NR_i386_renameat 302
#define __NR_i386_linkat 303
#define __NR_i386_symlinkat 304
#define __NR_i386_readlinkat 305
#define __NR_i386_fchmodat 306
#define __NR_i386_faccessat 307
#define __NR_i386_pselect6 308
#define __NR_i386_ppoll 309
#define __NR_i386_unshare 310
#define __NR_i386_set_robust_list 311
#define __NR_i386_get_robust_list 312
#define __NR_i386_splice 313
#define __NR_i386_sync_file_range 314
#define __NR_i386_tee 315
#define __NR_i386_vmsplice 316
#define __NR_i386_move_pages 317
#define __NR_i386_getcpu 318
#define __NR_i386_epoll_pwait 319
#define __NR_i386_utimensat 320
#define __NR_i386_signalfd 321
#define __NR_i386_timerfd_create 322
#define __NR_i386_eventfd 323
#define __NR_i386_fallocate 324
#define __NR_i386_timerfd_settime32 325
#define __NR_i386_timerfd_gettime32 326
#define __NR_i386_signalfd4 327
#define __NR_i386_eventfd2 328
#define __NR_i386_epoll_create1 329
#define __NR_i386_dup3 330
#define __NR_i386_pipe2 331
#define __NR_i386_inotify_init1 332
#define __NR_i386_preadv 333
#define __NR_i386_pwritev 334
#define __NR_i386_rt_tgsigqueueinfo 335
#define __NR_i386_perf_event_open 336
#define __NR_i386_recvmmsg 337
#define __NR_i386_fanotify_init 338
#define __NR_i386_fanotify_mark 339
#define __NR_i386_prlimit64 340
#define __NR_i386_name_to_handle_at 341
#define __NR_i386_open_by_handle_at 342
#define __NR_i386_clock_adjtime 343
#define __NR_i386_syncfs 344
#define __NR_i386_sendmmsg 345
#define __NR_i386_setns 346
#define __NR_i386_process_vm_readv 347
#define __NR_i386_process_vm_writev 348
#define __NR_i386_kcmp 349
#define __NR_i386_finit_module 350
#define __NR_i386_sched_setattr 351
#define __NR_i386_sched_getattr 352
#define __NR_i386_renameat2 353
#define __NR_i386_seccomp 354
#define __NR_i386_getrandom 355
#define __NR_i386_memfd_create 356
#define __NR_i386_bpf 357
#define __NR_i386_execveat 358
#define __NR_i386_socket 359
#define __NR_i386_socketpair 360
#define __NR_i386_bind 361
#define __NR_i386_connect 362
#define __NR_i386_listen 363
#define __NR_i386_accept4 364
#define __NR_i386_getsockopt 365
#define __NR_i386_setsockopt 366
#define __NR_i386_getsockname 367
#define __NR_i386_getpeername 368
#define __NR_i386_sendto 369
#define __NR_i386_sendmsg 370
#define __NR_i386_recvfrom 371
#define __NR_i386_recvmsg 372
#define __NR_i386_shutdown 373
#define __NR_i386_userfaultfd 374
#define __NR_i386_membarrier 375
#define __NR_i386_mlock2 376
#define __NR_i386_copy_file_range 377
#define __NR_i386_preadv2 378
#define __NR_i386_pwritev2 379
#define __NR_i386_pkey_mprotect 380
#define __NR_i386_pkey_alloc 381
#define __NR_i386_pkey_free 382
#define __NR_i386_statx 383
#define __NR_i386_arch_prctl 384
#define __NR_i386_io_pgetevents 385
#define __NR_i386_rseq 386
#define __NR_i386_semget 393
#define __NR_i386_semctl 394
#define __NR_i386_shmget 395
#define __NR_i386_shmctl 396
#define __NR_i386_shmat 397
#define __NR_i386_shmdt 398
#define __NR_i386_msgget 399
#define __NR_i386_msgsnd 400
#define __NR_i386_msgrcv 401
#define __NR_i386_msgctl 402
#define __NR_i386_clock_gettime64 403
#define __NR_i386_clock_settime64 404
#define __NR_i386_clock_adjtime64 405
#define __NR_i386_clock_getres_time64 406
#define __NR_i386_clock_nanosleep_time64 407
#define __NR_i386_timer_gettime64 408
#define __NR_i386_timer_settime64 409
#define __NR_i386_timerfd_gettime64 410
#define __NR_i386_timerfd_settime64 411
#define __NR_i386_utimensat_time64 412
#define __NR_i386_pselect6_time64 413
#define __NR_i386_ppoll_time64 414
#define __NR_i386_io_pgetevents_time64 416
#define __NR_i386_recvmmsg_time64 417
#define __NR_i386_mq_timedsend_time64 418
#define __NR_i386_mq_timedreceive_time64 419
#define __NR_i386_semtimedop_time64 420
#define __NR_i386_rt_sigtimedwait_time64 421
#define __NR_i386_futex_time64 422
#define __NR_i386_sched_rr_get_interval_time64 423
#define __NR_i386_pidfd_send_signal 424
#define __NR_i386_io_uring_setup 425
#define __NR_i386_io_uring_enter 426
#define __NR_i386_io_uring_register 427
#define __NR_i386_open_tree 428
#define __NR_i386_move_mount 429
#define __NR_i386_fsopen 430
#define __NR_i386_fsconfig 431
#define __NR_i386_fsmount 432
#define __NR_i386_fspick 433
#define __NR_i386_pidfd_open 434
#define __NR_i386_clone3 435
#define __NR_i386_close_range 436
#define __NR_i386_openat2 437
#define __NR_i386_pidfd_getfd 438
#define __NR_i386_faccessat2 439
#define __NR_i386_process_madvise 440
#define __NR_i386_epoll_pwait2 441
#define __NR_i386_mount_setattr 442
#define __NR_i386_landlock_create_ruleset 444
#define __NR_i386_landlock_add_rule 445
#define __NR_i386_landlock_restrict_self 446

#endif // !__FENNIX_KERNEL_LINUX_SYSCALLS_I386_H__
